Author: Bastian Waidelich Category: Core
Created: 2011-10-14 Assigned To: Christian Müller
Updated: 2015-06-15 Due date:
Has patch: No
Affected Flow version: FLOW3 1.0.0
Subject: Catch ViewHelper exceptions and log them in production context
Description

from line 241 of the AbstractViewHelper:

1try {
2    return call_user_func_array(array($this, 'render'), $renderMethodParameters);
3} catch (\TYPO3\Fluid\Core\ViewHelper\Exception $exception) {
4    // @todo [BW] rethrow exception, log, ignore.. depending on the current context
5    return $exception->getMessage();
6}

As the todo comment states, this should be caught in production context and logged to prevent information disclosure.
Code could look something like:

 1try {
 2    return call_user_func_array(array($this, 'render'), $renderMethodParameters);
 3} catch (\TYPO3\Fluid\Core\ViewHelper\Exception $exception) {
 4    if ($this->objectManager->getContext() === 'Development') {
 5        return $exception->getMessage();
 6    } else {
 7        $this->systemLogger->log([...]);
 8        return '';
 9    }
10}

Related issues:
related to Core - Bug # 32528: imageViewHelper should not throw exception Resolved 2011-12-14
duplicates TYPO3.Fluid - Feature # 9211: Improve ViewHelper exception handling Rejected 2010-08-09

Associated revisions
Revision 5fa13298 - 2011-11-10 14:18 - Christian Müller

[BUGFIX] ViewHelper Exceptions should be logged in Production

In Production context all Exceptions from ViewHelpers will be
silently logged. In Development they will be re-thrown so the global
exception handler will be triggered.
Resolves: #30935
Releases: 1.1
Change-Id: I4af4d03ff6048fcc8999f4a48d5c2897dc43fc4e

History
#1 - 2011-10-14 20:16 - Mr. Hudson

Patch set 2 of change I4af4d03ff6048fcc8999f4a48d5c2897dc43fc4e has been pushed to the review server.
It is available at http://review.typo3.org/5808

#2 - 2011-10-14 20:16 - Christian Müller
- Status changed from New to Under Review
- Assigned To set to Christian Müller

#3 - 2011-10-21 13:37 - Karsten Dambekalns
- Affected Flow version set to FLOW3 1.0.0

#4 - 2011-11-08 06:19 - Mr. Hudson

Patch set 3 of change I4af4d03ff6048fcc8999f4a48d5c2897dc43fc4e has been pushed to the review server.
It is available at http://review.typo3.org/5808

#5 - 2011-11-10 14:18 - Mr. Hudson

Patch set 4 of change I4af4d03ff6048fcc8999f4a48d5c2897dc43fc4e has been pushed to the review server.
It is available at http://review.typo3.org/5808

#6 - 2011-11-10 14:36 - Christian Müller
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:5fa13298c467f56d5e5f3fe5a6a233817144526d.

#7 - 2015-06-12 17:21 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40212

#8 - 2015-06-12 21:57 - Helmut Hummel

can be closed again, sorry ^^

#9 - 2015-06-15 09:45 - Bastian Waidelich

2015-08-03 2/3

http://review.typo3.org/5808
http://review.typo3.org/5808
http://review.typo3.org/5808
http://review.typo3.org/40212


- Status changed from Under Review to Resolved

No worries, thanks ;)
